﻿<%@ WebHandler Language="C#" Class="ImportLog" %>

using System;
using System.Web;
using System.Data;
using System.Text;
using System.IO;
using System.Data.SqlClient;
using System.Configuration;
using System.Web.UI;
using System.Web.UI.WebControls;

public class LineTemplate : ITemplate
{

    private ListItemType _TemplateType;

    public LineTemplate(ListItemType type)
    {
        _TemplateType = type;
    }

    private void TemplateControl_DataBinding(object sender, EventArgs e)
    {
        Literal lc = (Literal)sender;
        RepeaterItem container = (RepeaterItem)lc.NamingContainer;
        lc.Text += DataBinder.Eval(container.DataItem, "message").ToString() + "\r\n";
    }

#region ITemplate Members

public void  InstantiateIn(Control container)
{
        Literal lc = new Literal();

        switch (_TemplateType)
        {
            case ListItemType.Item:
                lc.DataBinding += TemplateControl_DataBinding;
                break;
        }

        container.Controls.Add(lc);
}

#endregion
}
public class ImportLog : IHttpHandler {
    
    public void ProcessRequest (HttpContext context) {
        context.Response.ContentType = "application/download";
        context.Response.AppendHeader("Content-Disposition", "attachment; filename=ImportLog.txt");

        string connstr = ConfigurationManager.ConnectionStrings["AdvantConnectionString"].ConnectionString;

        SqlConnection conn = new SqlConnection(connstr);
        
        SqlDataAdapter adapter = new SqlDataAdapter("SELECT id, message FROM [Catalog].[ImportLog]", conn);
        
        DataTable logTbl = new DataTable();
        conn.Open();
        adapter.Fill(logTbl);
        conn.Close();

        StringBuilder result = new StringBuilder();
        StringWriter writer = new StringWriter(result);
        HtmlTextWriter htmlWriter = new HtmlTextWriter(writer);
        
        Repeater rtr = new Repeater();
        rtr.ItemTemplate = new LineTemplate(ListItemType.Item);
        rtr.DataSource = logTbl;
        rtr.DataBind();

        rtr.RenderControl(htmlWriter);

        context.Response.Write(result);
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }

}