﻿<%@ WebHandler Language="C#" Class="FileDownloader" %>

using System;
using System.IO;
using System.Web;

public class FileDownloader : IHttpHandler {
    
    public void ProcessRequest (HttpContext context) {
        string filePath = context.Request["file"];
        if(!filePath.StartsWith("Export/"))
        {
            context.Response.End();
        }
        if(!File.Exists(context.Request.PhysicalApplicationPath + filePath))
        {
            context.Response.End();
        }
        string fileName = filePath.Substring(filePath.LastIndexOf("/") + 1, filePath.Length - filePath.LastIndexOf("/") - 1);
        context.Response.ContentType = "application/download";
        context.Response.AppendHeader("Content-Disposition", "attachment; filename=" + fileName);
        context.Response.TransmitFile(filePath);
    }
 
    public bool IsReusable {
        get {
            return true;
        }
    }

}