﻿<%@ WebHandler Language="C#" Class="RestoreDB" %>

using System;
using System.Web;
using System.Data.SqlClient;
using System.Configuration;
using System.IO;
using System.Data.Common;

public class RestoreDB : IHttpHandler
{

	// COM 

    private string __CONNECTION_STRING = @"data source=ms-sql-5.in-solve.ru;User ID=1gb_advant;Password=27022fa8;database=1gb_advant_en_demo_init";
    private string __FILE_PATH_STRING = @"D:\Web\MSSQL_BACKUP\\advant_en_demo_backup.bak";

    enum eRestoreDbMode { Normaly = 1, DirectRestore = 2 };

    private void restoreDb(eRestoreDbMode eRestoreType, HttpContext context)
    {
        switch (eRestoreType)
        {
            case eRestoreDbMode.Normaly:

                // Restore Normaly
                try
                {
                    string cs = ConfigurationManager.ConnectionStrings["AdvantConnectionString"].ConnectionString;

                    DbConnectionStringBuilder csbldr = new DbConnectionStringBuilder();
                    csbldr.ConnectionString = cs;

                    string dbName = csbldr["database"].ToString();

                    csbldr.ConnectionString = __CONNECTION_STRING;

                    string backupDBName = csbldr["database"].ToString();

                    using (SqlConnection conn = new SqlConnection(cs))
                    {
                        SqlCommand cmd = conn.CreateCommand();

                        cmd.CommandText = @"backup database [" + backupDBName
                            + @"] to disk = '" + __FILE_PATH_STRING + @"' with init; ALTER DATABASE ["
                            + dbName + @"] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;RESTORE DATABASE ["
                            + dbName + @"] FROM DISK = '" + __FILE_PATH_STRING + @"' WITH RECOVERY; ALTER DATABASE ["
                            + dbName + @"] SET MULTI_USER WITH ROLLBACK IMMEDIATE";

                        cmd.CommandType = System.Data.CommandType.Text;

                        conn.Open();
                        conn.ChangeDatabase("master");
                        cmd.ExecuteNonQuery();
                        conn.Close();
                    }
                }
                catch (Exception ex)
                {
                    context.Response.ContentType = "text/plain";
                    context.Response.Write(ex.Message);
                    AdvantShop.Core.Debug.LogError(ex);
                }

                break;

            case eRestoreDbMode.DirectRestore:

                // Restore Normaly
                try
                {
                    string cs = ConfigurationManager.ConnectionStrings["AdvantConnectionString"].ConnectionString;

                    DbConnectionStringBuilder csbldr = new DbConnectionStringBuilder();
                    csbldr.ConnectionString = cs;

                    string dbName = csbldr["database"].ToString();

                    csbldr.ConnectionString = __CONNECTION_STRING;

                    string backupDBName = csbldr["database"].ToString();

                    //using (SqlConnection conn = new SqlConnection(cs))
                    using (SqlConnection conn = new SqlConnection(__CONNECTION_STRING))
                    {
                        SqlCommand cmd = conn.CreateCommand();

                        cmd.CommandText = @"backup database [" + backupDBName + @"] to disk = '" + __FILE_PATH_STRING + @"' with init; " +
                                          @"RESTORE DATABASE [" + dbName + @"] FROM DISK = '" + __FILE_PATH_STRING + @"' WITH RECOVERY;";

                        cmd.CommandType = System.Data.CommandType.Text;

                        conn.Open();
                        conn.ChangeDatabase("master");
                        cmd.ExecuteNonQuery();
                        conn.Close();
                    }
                }
                catch (Exception ex)
                {
                    context.Response.ContentType = "text/plain";
                    context.Response.Write(ex.Message);
                    AdvantShop.Core.Debug.LogError(ex);
                }

                break;
        }

    }

    public void ProcessRequest(HttpContext context)
    {

        // Ping DB first ---------------------------------------------------------------------------
        try
        {
            if (AdvantShop.Core.DataBaseService.PingDateBase())
            {
                // Success
                restoreDb(eRestoreDbMode.Normaly, context);
            }
            else
            {
                // Faild
                restoreDb(eRestoreDbMode.DirectRestore, context);
            }
        }
        catch (Exception ex)
        {
            context.Response.ContentType = "text/plain";
            context.Response.Write(ex.Message);
            AdvantShop.Core.Debug.LogError(ex);
            return;
        }

        context.Response.ContentType = "text/plain";
        context.Response.Write("Database successfully restored");

        // Restore product pic files -----------------------------------------------------------------
        try
        {
            Directory.Delete(context.Server.MapPath("~/products_pictures"), true);
            Directory.CreateDirectory(context.Server.MapPath("~/products_pictures"));

            if (Directory.Exists(context.Server.MapPath("~/products_pictures")))
            {
                foreach (string filename in Directory.GetFiles(context.Server.MapPath("~/products_pictures_default"), "*.jpg"))
                {
                    File.Copy(filename, context.Server.MapPath("~/products_pictures") + filename.Substring(filename.LastIndexOf('\\')));
                }
            }
            else
            {
                Directory.CreateDirectory(context.Server.MapPath("~/products_pictures_default"));
            }
        }
        catch (Exception ex)
        {
            context.Response.ContentType = "text/plain";
            context.Response.Write(ex.Message);
            AdvantShop.Core.Debug.LogError(ex);
            return;
        }

        // Restore product news files -----------------------------------------------------------------
        try
        {
            Directory.Delete(context.Server.MapPath("~/news_pictures"), true);
            Directory.CreateDirectory(context.Server.MapPath("~/news_pictures"));

            if (Directory.Exists(context.Server.MapPath("~/news_pictures_default")))
            {
                foreach (string filename in Directory.GetFiles(context.Server.MapPath("~/news_pictures_default"), "*.jpg"))
                {
                    File.Copy(filename, context.Server.MapPath("~/news_pictures") + filename.Substring(filename.LastIndexOf('\\')));
                }
            }
            else
            {
                Directory.CreateDirectory(context.Server.MapPath("~/news_pictures_default"));
            }
        }
        catch (Exception ex)
        {
            context.Response.ContentType = "text/plain";
            context.Response.Write(ex.Message);
            AdvantShop.Core.Debug.LogError(ex);
            return;
        }

        context.Response.Write("Pictures successfully restored");
    }

    public bool IsReusable
    {
        get { return true; }
    }

}